﻿## Automate NSX Logical Switch Creation
## Author: Terrance Levon Johnson
## Substitute Variable information in lines 6 through 11 with information that matches your environment.
## Point Variable in line 13 to the file location of the Logical_Switch_Creation csv file.   

$NSXManagerIP = "192.168.0.176"
$VCenterIP = "192.168.0.78"
$NSXManagerUser = "admin"
$NSXManagerPassword = "Password"
$VCenterUser = "administrator@vsphere.local"
$VCenterPassword = "VCenterPassword"

$NSXLOGICALSWITCHFILE = import-csv C:\work\NSX_PowerNSX\Logical_Switch_Creation.csv

Connect-NsxServer -Server $NSXManagerIP -Username $NSXManagerUser -Password $NSXManagerPassword -ViUserName $VCenterUser -ViPassword $VCenterPassword

$LS = 0

foreach ($LogicalSwitch in $NSXLOGICALSWITCHFILE)
{
## Creates Logical Switches for NSX. Possible Control Plane Modes are UNICAST_MODE,HYBRID_MODE,MULTICAST_MODE
Get-NsxTransportZone | New-NsxLogicalSwitch -Name $LogicalSwitch.LogicalSwitchName -ControlPlaneMode UNICAST_MODE

$LS++
Write-Progress -Activity "Creating Logical Switches" -status "Created: $LS of $($NSXLOGICALSWITCHFILE.Count)" -PercentComplete (($LS / $NSXLOGICALSWITCHFILE.Count) * 100)

}

Write-Host "!!!All Logical Switches Created Sucsessfully" -ForegroundColor Green
